<?php
/**
 * @package Pro.Radio Podcast Importer
 * @version 1.0.0
*/
// don't load directly
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
if(!function_exists('prpimp_podcasttask_register_type')){
	add_action('init', 'prpimp_podcasttask_register_type',9999);  
	function prpimp_podcasttask_register_type() {
		$labelspodcast = array(
			'name' 					=> esc_html__("Podcast Importer","proradio-podcast-importer"),
			'singular_name' 		=> esc_html__("Podcast Importer","proradio-podcast-importer"),
			'add_new' 				=> esc_html__("Add new","proradio-podcast-importer"),
			'add_new_item' 			=> esc_html__("Add new RSS Feed","proradio-podcast-importer"),
			'edit_item' 			=> esc_html__("Edit RSS Feed","proradio-podcast-importer"),
			'new_item' 				=> esc_html__("New feed","proradio-podcast-importer"),
			'all_items' 			=> esc_html__("All feed","proradio-podcast-importer"),
			'view_item' 			=> esc_html__("View feed","proradio-podcast-importer"),
			'search_items'	 		=> esc_html__("Search feed","proradio-podcast-importer"),
			'not_found' 			=> esc_html__("No feed found","proradio-podcast-importer"),
			'not_found_in_trash' 	=> esc_html__("No feed found in trash","proradio-podcast-importer"),
			'menu_name' 			=> esc_html__("Podcast feeds","proradio-podcast-importer")
		);
		$args = array(
			'labels'                    => $labelspodcast,
			'public'                    => false,
			'publicly_queryable'        => false,
			'show_ui'                   => true, 
			'show_in_menu'              => true, 
			'query_var'                 => true,
			'rewrite'                   => false,
			'capability_type'           => 'page',
			'has_archive'               => true,
			'hierarchical'              => false,
			'menu_position'             => 62,
			'page-attributes'           => true,
			'show_in_nav_menus'         => true,
			'show_in_admin_bar'         => true,
			'show_in_menu'              => true,
			'menu_icon'                => 'dashicons-megaphone',
			'supports'                  => array('title' ),
			'show_in_rest'              => false,
		); 
		register_post_type( "prpimp-task" , $args );
		$taxonomyselect = get_option( 'proradio_pimp_taxonomy', 'podcastfilter' );
		if( !is_null( $taxonomyselect ) && taxonomy_exists( $taxonomyselect ) ){
		    register_taxonomy_for_object_type($taxonomyselect, "prpimp-task" );
		}
		$service  = function_exists('prpimp_whmcs_check_service_standalone') ? prpimp_whmcs_check_service_standalone(base64_decode(PRORADIO_PIMP_SERVICE_NAME))  : false;
		if( $service && strtotime($service) > time() ){
			$podcast_tab_custom = array(
				array(
					'label' => esc_html__( 'Enable feed', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Include this podcast source in the automatic routine', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-auto',
					'type'  => 'checkbox'
				),
				array(
					'label' => esc_html__( 'Podcast RSS Feed URL', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-feed-url',
					'type'  => 'url'
				),
		
				array(
					'label' => esc_html__( 'Import description', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Import the episode desciption as post content', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-importcontent',
					'type'  => 'checkbox'
				),
				array(
					'label' => esc_html__( 'Strip links', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Remove links and HTML from the content', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-striplinks',
					'type'  => 'checkbox'
				),
				array(
					'label' => esc_html__( 'Import category', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Create missing categories for this podcast', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-importcategory',
					'type'  => 'checkbox'
				),
				array(
					'label' => esc_html__( 'Link to source', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Display a link to the original podcast source. Usually required by copyright and redistribution rules.', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-linksource',
					'type'  => 'checkbox'
				),
				array(
					'label' => esc_html__( 'Artwork import', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Try to download and import the artwork in your media library', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-artwork-import',
					'type'  => 'checkbox'
				),
				array(
					'label' => esc_html__( 'Default artwork', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Set a default artwork if the download fails or is disabled', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-artwork-default',
					'type'  => 'image'
				),
			);
		} else {
			$promotest = '[Available with Importer Premium]';
			$podcast_tab_custom = array(
				array(
					'label' => esc_html__( 'Enable feed', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Include this podcast source in the automatic routine', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-auto',
					'type'  => 'checkbox'
				),
				array(
					'label' => esc_html__( 'Podcast RSS Feed URL', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-feed-url',
					'type'  => 'url'
				),
		
				array(
					'label' => esc_html__( 'Import description', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Import the episode desciption as post content', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-importcontent',
					'type'  => 'checkbox'
				),
				array(
					'label' => esc_html__( 'Strip links', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Remove links and HTML from the content', 'proradio-podcast-importer' ).' '.$promotest ,
					'id'    => 'prpimp-striplinks',
					'type'  => 'static'
				),
				array(
					'label' => esc_html__( 'Import category', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Create missing categories for this podcast', 'proradio-podcast-importer' ).' '.$promotest ,
					'id'    => 'prpimp-importcategory',
					'type'  => 'static'
				),
				array(
					'label' => esc_html__( 'Link to source', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Display a link to the original podcast source. Usually required by copyright and redistribution rules.', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-linksource',
					'type'  => 'checkbox'
				),
				array(
					'label' => esc_html__( 'Artwork import', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Try to download and import the artwork in your media library', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-artwork-import',
					'type'  => 'checkbox'
				),
				array(
					'label' => esc_html__( 'Default artwork', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Set a default artwork if the download fails or is disabled', 'proradio-podcast-importer' ).' '.$promotest,
					'id'    => 'prpimp-artwork-default',
					'type'  => 'static'
				),
			);
		}
		$podcast_tab_custom_debug = array(
				array(
					'label' => esc_html__( 'Started import', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Last time this task started', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-start',
					'type'  => 'readonly'
				),
				array(
					'label' => esc_html__( 'Completed import', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Last time this task ended clean', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-last',
					'type'  => 'readonly'
				),
				array(
					'label' => esc_html__( 'Debug log', 'proradio-podcast-importer' ),
					'desc' => esc_html__( 'Result of execution', 'proradio-podcast-importer' ),
					'id'    => 'prpimp-log',
					'type'  => 'readonly'
				),
			);

		if(get_option('proradio_pimp_debug')){
			$podcast_tab_custom = array_merge($podcast_tab_custom_debug, $podcast_tab_custom );
		}

		if (class_exists('PrCustomPlugin_Custom_Add_Meta_Box')){
			$podcast_tab_custom_box = new PrCustomPlugin_Custom_Add_Meta_Box( 'podcast_customtab', esc_html__('RSS Feed settings', 'proradio-podcast-importer'), $podcast_tab_custom, 'prpimp-task', true );
		} else {
			die('Missing Custom Metaboxes Class');
		}
	}
}

function prpimp_limit_user_posts($data, $postarr) {
    $service = function_exists('prpimp_whmcs_check_service_standalone') ? prpimp_whmcs_check_service_standalone(base64_decode(PRORADIO_PIMP_SERVICE_NAME)) : false;
    
    if ($service && strtotime($service) > time()) {
        // Allow users to trash posts freely
        if (isset($data['post_status']) && $data['post_status'] === 'trash') {
            return $data;
        }

        // Only apply to the 'prpimp-task' post type
        if ($data['post_type'] !== 'prpimp-task') {
            return $data;
        }

        // Allow updates to existing posts (post_ID exists)
        if (!empty($postarr['ID'])) {
            return $data;
        }

        // Get the current user ID
        $user_id = get_current_user_id();

        // Count only non-trashed posts
        $args = [
            'post_type'      => 'prpimp-task',
            'post_status'    => ['publish', 'draft', 'pending', 'future', 'private'], // Exclude 'trash'
            'author'         => $user_id,
            'posts_per_page' => -1,
            'fields'         => 'ids',
        ];
        $existing_posts = get_posts($args);

        // If the user already has 3 or more non-trashed posts, block any new creation
        if (count($existing_posts) >= 1) {
            wp_die(__('❌ With the free version of Podcast Importer, you can only have 1 RSS Feed sources (including drafts). Please delete one before adding a new one.', 'proradio-podcast-importer'), __('Limit Exceeded', 'proradio-podcast-importer'), [
                'response' => 403
            ]);
        }
    }

    return $data;
}

// Hook into post publishing process
add_filter('wp_insert_post_data', 'prpimp_limit_user_posts', 10, 2);

