<?php 
/**
 * @package ProRadio Podcast Importer
 * Delete all imported podcasts
 * */

if ( ! defined( 'ABSPATH' ) ) {
    die( '-1' );
}



/**
 * =====================================================
 * Legal disclaimer acceptance
 * =====================================================
 * */
function prpimp_delete_all_imported_posts() {
    if (isset($_POST['proradio_pimp_confirm_delete']) && $_POST['proradio_pimp_confirm_delete'] === 'DELETE') {
        // Check if nonce is valid to prevent CSRF
        if (check_admin_referer('prpimp_delete_nonce_action', 'prpimp_delete_nonce')) {
            
            // Query posts with the specific meta key
            $args = array(
                'post_type' => 'any', // Adjust if using custom post types
                'meta_key' => 'proradio-pimp-imported',
                'meta_value' => '1',
                'posts_per_page' => -1, // Get all matching posts
                'post_status' => 'any', // Include all post statuses
            );

            $query = new WP_Query($args);

            // Loop through and move all posts to trash
            if ($query->have_posts()) {
                while ($query->have_posts()) {
                    $query->the_post();
                    wp_trash_post(get_the_ID());
                }
            }

            // Reset post data
            wp_reset_postdata();

            // Display success message
            add_action('admin_notices', function() {
                ?><div class="notice notice-success is-dismissible"><p><?php esc_html_e('All imported podcasts have been moved to the trash.', 'proradio-podcast-importer'); ?></p></div><?php  
            });

            // Redirect to the settings page after deletion
            wp_redirect(admin_url('admin.php?page=proradio-podcastimport-settings'));
            exit;
        }
    }
}
add_action('admin_init', 'prpimp_delete_all_imported_posts');

