<?php  
/**
 * ==================================================
 * Settings section
 * ==================================================
 * */
	
$controls = array();
$service = function_exists('prpimp_whmcs_check_service_standalone') ? prpimp_whmcs_check_service_standalone(base64_decode(PRORADIO_PIMP_SERVICE_NAME))     : false;	              
 	
$controls[] = array(
	'type'	=> 'section',
	'label'	=> esc_html__('Podcast Importer', 'proradio-podcast-importer'),
);



if( !$service  || strtotime($service) < time()){
 	$desc = esc_html__( 'This option is limited to 1 run per day in the free version.', 'proradio-podcast-importer' );
} else {
	$desc =  esc_html__('Set the time interval (in minutes) for running the podcast import function. At each interval, the system will process the specified number of episodes. Minimum: 15 minutes.', 'proradio-podcast-importer');
}
$controls[] = array(
	'id' => 'proradio_pimp_cronfreq',
	'type'	=> 'radio',
	'label'	=> esc_html__('Import Cron Frequency (Minutes)', 'proradio-podcast-importer'),
	'description'	=> $desc,
	'default' => 1440,
	'advanced' => 1,
	'options' => array(
		30 	=> esc_html__('30 Minutes' , 'proradio-ajax'),
		60 	=> esc_html__('1 Hour' , 'proradio-ajax'),
		720 	=> esc_html__('12 Hours' , 'proradio-ajax'),
		1440 	=> esc_html__('24 Hours' , 'proradio-ajax'),
	)
);

if( !$service || strtotime($service) < time() ){
 	$desc = esc_html__( 'This option is limited to 3 episodes per run in the free version.', 'proradio-podcast-importer' );
} else {
	$desc =  esc_html__( 'Hard limit: 50 episodes per run. Trigger again to import more episodes. A higher number implies higher server load.', 'proradio-podcast-importer' );
}

$controls[] = array(
	'id' => 'proradio_pimp_batchquantity',
	'type'	=> 'number',
	'advanced' => 1,
	'min' => 1,
	'max' => 50,
	'default' => 3,
	'label'       => esc_html__( 'Number of episodes to process per run for each RSS feed source.', 'proradio-podcast-importer' ),
	'description' =>  $desc
);

$theme = wp_get_theme();
$parent_theme = $theme->parent();
$theme_name = $parent_theme ? $parent_theme->get('Name') : $theme->get('Name');
switch($theme_name){
	case "OnAir2":
	case "Pro Radio":
	case "Vice":
	case "Kentha":
	case "WpCasterPro":
		$posttype = "podcast";
		break;
	case "WpCast":
	default:
		$posttype = "post";
}

$controls[] = array(
	'id' => 'proradio_pimp_posttype',
	'default' => $posttype,
	'type'	=> 'posttypeselect',
	'label'	=> esc_html__('Post type', 'proradio-podcast-importer'),
	'description'	=> esc_html__('In which post type you want to import the feeds','proradio-podcast-importer').'. Preselected for theme '.$theme_name
);


switch($theme_name){
	case "OnAir2":
	case "Pro Radio":
	case "Vice":
	case "Kentha":
		$taxonomyname = 'podcastfilter';
		break;
	case "WpCasterPro":
		$taxonomyname = "qtserie";
		break;
	case "Vice":
		$taxonomyname = 'filter';
		break;
	case "WpCast":
		$taxonomyname = "qtserie";
		break;
	default:
		$taxonomyname = "category";
}
$controls[] = array(
	'id' => 'proradio_pimp_taxonomy',
	'type'	=> 'taxonomyselect',
	'default' => $taxonomyname,
	'label'	=> esc_html__('Taxonomy', 'proradio-podcast-importer'),
	'description'	=> esc_html__('Which taxonomy to use as category','proradio-podcast-importer')
);


$controls[] = array(
	'id' => 'proradio_pimp_debug',
	'type'	=> 'checkbox',
	'label'	=> esc_html__('Debug fields', 'proradio-podcast-importer'),
	'description'	=> esc_html__('Enable debug output fields in the Rss Feed data', 'proradio-podcast-importer'),
);

$controls[] = array(
	'id' => 'prpimp_licensekey_'.prpimp_iid(),
	'type'	=> 'licensekey',
	'label'	=> esc_html__('License Key', 'proradio-podcast-importer'),
	'description'	=> esc_html__('Unlock premium features. Copy the license key from your shop client area.', 'proradio-podcast-importer'),
);

$nonce_action = 'proradio_pimp_settings_save';
$nonce_name = 'proradio_pimp_settings_nonce';
$title = esc_html__("Settings",'proradio-podcast-importer');

if(function_exists('proradio_pimp_form_generator')){
	proradio_pimp_form_generator( $title, $controls, $nonce_action , $nonce_name); 
}
		