<?php  
/**
 * @package Proradio
 * @author Qantum Themes  
 * @version 6.6.4
 * @date 2024 08 24
 * */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}


if(!function_exists('prpimp_custom_whmcs_check_license')){
function prpimp_custom_whmcs_check_license($licensekey, $localkey='') {

	$proxy_status = get_option( 'proradio_proxy_switcher', true ) ;
	$proradio_debug_mode = 0;
	$whmcsurl = 'https://pro.radio/shop/';
	$licensing_secret_key = '7EnfeEBLEs-INtroverT974';
	$localkeydays = 30;
	$allowcheckfaildays = 21;
	$check_token = time() . md5(mt_rand(100000000, mt_getrandmax()) . $licensekey);
	$checkdate = date("Ymd");
	$site = parse_url(get_site_url());
	$domain = $site['host'];
	$usersip = isset($_SERVER['SERVER_ADDR']) ? $_SERVER['SERVER_ADDR'] : $_SERVER['LOCAL_ADDR'];
	$dirpath = dirname(__FILE__);

	$localkeyvalid = false;

	/**
	 * ============================================================================================
	 * API URl
	 * ===========================================================================================
	 * */
	if( $proxy_status ){
		$whmcs_request_url =  $whmcsurl . 'modules/servers/licensing/verify.php';
	} else {
		$whmcs_request_url =  'https://whmcs-verify-proxy.pro.radio/verify.php';
	}
	// ==========================================================================================
	// ==========================================================================================

	if ($localkey) {

		$localkey = str_replace("\n", '', $localkey); # Remove the line breaks
		$localdata = substr($localkey, 0, strlen($localkey) - 32); # Extract License Data
		$md5hash = substr($localkey, strlen($localkey) - 32); # Extract MD5 Hash
		if ($md5hash == md5($localdata . $licensing_secret_key)) {
			$localdata = strrev($localdata); # Reverse the string
			$md5hash = substr($localdata, 0, 32); # Extract MD5 Hash
			$localdata = substr($localdata, 32); # Extract License Data
			$localdata = base64_decode($localdata);
			$localkeyresults = json_decode($localdata, true);
			$originalcheckdate = $localkeyresults['checkdate'];
			if ($md5hash == md5($originalcheckdate . $licensing_secret_key)) {
				$localexpiry = date("Ymd", mktime(0, 0, 0, date("m"), date("d") - $localkeydays, date("Y")));
			

				if ($originalcheckdate > $localexpiry) {
					$localkeyvalid = true;

					$results = $localkeyresults;
					$validdomains = explode(',', $results['validdomain']);
					if (!in_array($domain, $validdomains)) { // test
						$localkeyvalid = false;
						echo 'Domain invalid';
						$localkeyresults['status'] = "Invalid";
						
						if( $proradio_debug_mode ){
							echo '<strong>Invalid domain:</strong>'.$domain .' <br> Allowed domain: '.$results['validdomain'].'<br>';
						}
						$results = array();
					}
					// ==============================
					// Check the IP
					// ===============================
					$productname =  $results['productname']; // Example product name
                    $validips = explode(',', $results['validip']);
					if (!in_array($usersip, $validips)) {
						$localkeyvalid = false;
						echo 'IP invalid';
						$localkeyresults['status'] = "Invalid";
						if( $proradio_debug_mode ){
							echo '<br><strong>Invalid IP:</strong>'.$usersip.'<br>Valid IP: '.$results['validip'].'<br>';
						}
						$results = array();
					}
				}
			}
		}
	} 
	if (!$localkeyvalid) {
		update_option( 'prpimp_ack_' . prpimp_iid(), false );
		

		if(!$licensekey){
			return;
		}

		$responseCode = 0;
		$postfields = array(
			'licensekey' => $licensekey,
			'domain' => $domain,
			'ip' => $usersip,
			'dir' => $dirpath,
		);
		if ($check_token) $postfields['check_token'] = $check_token;
		$query_string = '';
		foreach ($postfields AS $k=>$v) {
			$query_string .= $k.'='.urlencode($v).'&';
		}

		if (function_exists('curl_exec')) {
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $whmcs_request_url);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $query_string);
			curl_setopt($ch, CURLOPT_TIMEOUT, 30);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
			$data = curl_exec($ch);
			$responseCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
			curl_close($ch);
		} else {
			$responseCodePattern = '/^HTTP\/\d+\.\d+\s+(\d+)/';
			$fp = @fsockopen($whmcsurl, 80, $errno, $errstr, 5);
			if ($fp) {
				$newlinefeed = "\r\n";
				$header = "POST ".$whmcs_request_url . " HTTP/1.0" . $newlinefeed;
				$header .= "Host: ".$whmcsurl . $newlinefeed;
				$header .= "Content-type: application/x-www-form-urlencoded" . $newlinefeed;
				$header .= "Content-length: ".@strlen($query_string) . $newlinefeed;
				$header .= "Connection: close" . $newlinefeed . $newlinefeed;
				$header .= $query_string;
				$data = $line = '';
				@stream_set_timeout($fp, 20);
				@fputs($fp, $header);
				$status = @socket_get_status($fp);
				while (!@feof($fp)&&$status) {
					$line = @fgets($fp, 1024);
					$patternMatches = array();
					if (!$responseCode
						&& preg_match($responseCodePattern, trim($line), $patternMatches)
					) {
						$responseCode = (empty($patternMatches[1])) ? 0 : $patternMatches[1];
					}
					$data .= $line;
					$status = @socket_get_status($fp);
				}
				@fclose ($fp);
			}
		}

		// Debug ==========================================================================================================
		// Debug ==========================================================================================================
		// Debug ==========================================================================================================
		if( $proradio_debug_mode ){
			echo '<pre>';
			print_r($data);echo '</pre>';
			
		}
		// ================================================================================================================
		// ================================================================================================================
		// ================================================================================================================
		// ================================================================================================================
		if ($responseCode != 200) {
			if( $proradio_debug_mode ){
				echo 'API Call: '.$whmcs_request_url.'<br>';
				echo 'Proxy Status: '; echo  ($proxy_status)? 'ON' : 'OFF' ;
			}
			$localexpiry = date("Ymd", mktime(0, 0, 0, date("m"), date("d") - ($localkeydays + $allowcheckfaildays), date("Y")));
			if ($originalcheckdate > $localexpiry) {
				$results = $localkeyresults;
			} else {
				$results = array();
				$results['status'] = "Invalid";
				$results['description'] = "Remote Check Failed";
				return $results;
			}
		} else {
			preg_match_all('/<(.*?)>([^<]+)<\/\\1>/i', $data, $matches);
			$results = array();
			foreach ($matches[1] AS $k=>$v) {
				$results[$v] = $matches[2][$k];
			}
		}
		if (!isset($results) ||  !is_array($results)) {
			if( $proradio_debug_mode ){
				echo 'API Call: '.$whmcs_request_url.'<br>';
				echo 'Proxy Status: '; echo  ($proxy_status)? 'ON' : 'OFF' ;
			}
			die("Invalid License Server Response");
		}
		if(!array_key_exists('md5hash', $results)){
			$results['status'] = "Invalid";
			return $results;
		}
		if ($results['md5hash']) {
			if ($results['md5hash'] != md5($licensing_secret_key . $check_token)) {
				$results['status'] = "Invalid";
				$results['description'] = "MD5 Checksum Verification Failed";
				return $results;
			}
		}
		if ($results['status'] == "Active" || $results['status'] == "Suspended") {
			$results['checkdate'] = $checkdate;
			$data_encoded = json_encode($results);
			$data_encoded = base64_encode($data_encoded);
			$data_encoded = md5($checkdate . $licensing_secret_key) . $data_encoded;
			$data_encoded = strrev($data_encoded);
			$data_encoded = $data_encoded . md5($data_encoded . $licensing_secret_key);
			$data_encoded = wordwrap($data_encoded, 80, "\n", true);
			$results['localkey'] = $data_encoded;
			update_option( 'prpimp_ack_' . prpimp_iid(), $data_encoded );
		}
		$results['remotecheck'] = true;
	}
	unset($postfields,$data,$matches,$whmcsurl,$licensing_secret_key,$checkdate,$usersip,$localkeydays,$allowcheckfaildays,$md5hash);
	return $results;
}}