// nothing yet

/**
 * =======================================
 * Admin script for proradio_pimp admin
 * =======================================
 * */
(function($) {
	"use strict";

	$.Prpimp = {
		totalImport: 0,
		totalSkipped: 0,
		totalAnalyzed: 0,
		totalRequested: 0,
		out: function(text){
			var $logContainer = $('.proradio_pimp-ajax-importer-output');
        	$logContainer.append('<p>' + text + '</p>');
			$logContainer.scrollTop($logContainer.prop("scrollHeight"));
		},

		// For each rss feed, call an ajax function that can download the xml, split ito tasks and delete the task once done
		generateTasksQueue: function(task_id, totalItems, $index) {
		    $.ajax({
	            url: proradio_pimp_ajax_var.url, // WordPress global AJAX handler
	            type: 'POST',
	            dataType: 'json',
	            data: {
	                action: 'prpimp_generate_tasks_queue',
	                task_id: task_id,
	                nonce: proradio_pimp_ajax_var.nonce  // Pass the nonce
	            },
	            beforeSend: function() {
	                $.Prpimp.out('<p>Generate queue of tasks</p>');
	            },
	            success: function(jsonData) {
	            	var total_items = jsonData.total_items;
	            	var total_imported = jsonData.total_imported;
	            	var skipped = jsonData.skipped;
	            	var limit = jsonData.limit;
	            	var result = jsonData.result; // success or fail

	            	// Global counters
	            	if( total_imported ) $.Prpimp.totalImport += total_imported;
	            	if( skipped ) $.Prpimp.totalSkipped += skipped;
	            	if( total_items ) $.Prpimp.totalAnalyzed += total_items;
	            	if( limit ) $.Prpimp.totalRequested += limit;

	            	if( result === 'success' ){
		            	$.Prpimp.out( 'Task: '+task_id+'  '+result+ ' Episodes available: '+total_items+  ' Limit:'+ limit +' Skipped: '+skipped+ ' Imported: '+total_imported);
		            } else {
		            	$.Prpimp.out(  'Task: '+task_id+' ' + result );
		            }
		            var progress = ($index / totalItems) * 100;
		            $.Prpimp.progress(progress);

		            if( totalItems == $index ){
				    	$('[data-prpimp-ajaximport]').removeClass('disabled').text('Done!').css({'pointer-events':'none'});
				    	$.Prpimp.out('Done! Imported: ' + $.Prpimp.totalImport +' episodes. Skipped: '+ $.Prpimp.totalSkipped + ' Analyzed:'+ $.Prpimp.totalAnalyzed +' Requested:'+ $.Prpimp.totalRequested );
				    }
	            },
	            error: function(xhr, status, error) {
	                $.Prpimp.out('Error: ' + error );
	            }
	        });

		},
		progress: function(percent){
			$('.proradio_pimp-progress-bar').addClass('active').css({'width': percent+'%'});
			if( percent == 100){
				$('.proradio_pimp-progress-bar').addClass('done');
			}
		},
		// Link click to start
		buttonClick: function(){
			$(document).on('click', '[data-prpimp-ajaximport]', function(e) {
		        e.preventDefault();

		        $.Prpimp.progress(5);
		       
		        var button = $(this);
		        button.addClass('disabled').text('Processing').css({'pointer-events':'none'});
		        $.ajax({
		            url: proradio_pimp_ajax_var.url, // WordPress global AJAX handler
		            type: 'POST',
		            dataType: 'json',
		            data: {
		                action: 'prpimp_get_tasks_list',
		                nonce: proradio_pimp_ajax_var.nonce  // Pass the nonce
		            },
		            beforeSend: function() {
		            	 $.Prpimp.progress(10);
		       
		                $.Prpimp.out('<p>Extracting list of active feed sources</p>');
		            },
		            success: function(jsonData) {
		            	var totalItems = Object.keys(jsonData).length;
		            	$.Prpimp.out('Found '+ totalItems +' feeds to import');
		            	var $index = 1;
		            	$.each(jsonData, function(key, value) {
						    $.Prpimp.generateTasksQueue(key, totalItems, $index);
						   

						     $index += 1;
						});
		            },
		            error: function(xhr, status, error) {
		                 $.Prpimp.out('Error: ' + error );
		            }
		        });
		    });
		},
		init: function(){
			console.log('Podcast Importer Init');
			$.Prpimp.buttonClick();
		}
	};

	/**====================================================================
	 *
	 *	Page Ready Trigger
	 * 
	 ====================================================================*/
	jQuery(document).ready(function() {
		$.Prpimp.init();
	});
})(jQuery);