<?php 
/**
 * @package Pro.Radio Podcast Importer
 * Run all import tasks
 * 
 * */
if ( ! defined( 'ABSPATH' ) ) { exit; }

/***
 * =============================================
 * This funcion runs the import for all active tasks
 * =============================================
 * */
if(!function_exists('prpimp_run_tasks')){
    function  prpimp_run_tasks() {
        $args = array(
            'post_type'   => 'prpimp-task',
            'post_status' => 'publish',
            'meta_query'  => array(
                array(
                    'key'     => 'prpimp-auto',
                    'value'   => '1',
                    'compare' => '=',
                ),
            ),
            'fields'      => 'ids',
        );
        $query = new WP_Query($args);
        if ($query->have_posts()) {
            foreach ($query->posts as $task_id) {
                $result = prpimp_import_podcast_feed_to_wp($task_id);
                echo esc_html($result).' Imported';
            }
        }
    }
}